---
layout: markdown_page
title: "Product Direction - Monitor"
description: "The Monitor stage comes after you've configured your production infrastructure and deployed your application to it. Learn more here!"
canonical_path: "/direction/monitor/"
---

## On this page
{:.no_toc}

- TOC
{:toc}

This is the product direction for Monitor. If you'd like to discuss this direction
directly with the product managers for Monitor, feel free to reach out to Kevin Chu (Group PM of Monitor) ([GitLab](https://gitlab.com/kbychu), [Email](mailto:kchu@gitlab.com) [Zoom call](https://calendly.com/kchu-gitlab/30min)).

<%= devops_diagram(["Monitor"]) %>

## Mission
The mission of the GitLab Monitor stage is to provide feedback on the health and performance of your system so that you can decrease the frequency and severity of incidents.

## Landscape
The Monitor stage directly competes in several [markets defined within our Ops Section](/direction/ops/#market), including Application Performance Monitoring (APM), Log Management, Infrastructure Monitoring, IT Service Management (ITSM), Digital Experience Management (DEM) and Product Analytics. The total addressable market for the Monitor stage is projected to be [$2.7 billion](https://about.gitlab.com/handbook/product/investment/#total-and-service-addressable-markets) by 2024. 

All of these markets are well-established and crowded, with winning companies achieving spectacular growth as businesses continue to shift online.

Successful vendors, such as market leader [Datadog](https://www.datadoghq.com/) are leveraging a [platform strategy](https://mitsloan.mit.edu/ideas-made-to-matter/platform-strategy-explained) to expand their markets (see DataDog's [acquisition of Undefined Labs to expand beyond production applications to provide code insights during development](https://drive.google.com/file/d/1hq74bZvBv5nD6Krmi-iaSsdqA9ChOf1r/view), or their expansion to [incident management in 2020](https://www.datadoghq.com/blog/dash-2020-new-feature-roundup/)). Competition among market leaders today is also geared toward making the whole stack observable for enterprises. [New Relic's updated business model](https://blog.newrelic.com/product-news/new-relic-one-observability-made-simple/) reflects the need for vendors to capture increasing footprint (and spend) of enterprises while enabling future growth by making a significant part of their business free.

## Vision
The vision of the Monitor stage is to enable DevOps team to operate their application by enabling monitoring, observability, incident response, and feedback all within a [single application](https://about.gitlab.com/direction/#vision), GitLab.

Everyone needs monitoring. We want everyone to be able to access it, without an exorbitant cost that constantly needs to be monitored, and without specialized skills to use the tools in order to get the benefit. In short, we would like Monitoring to be commoditized and democratized.

## Strategy
To achieve our vision, our strategy is to:

1. Focus first on user adoption and dogfooding of Incident Management
1. Strengthen bi-directional product tie-in to other GitLab stage capabilities
1. Build a [boring](https://about.gitlab.com/handbook/values/#boring-solutions) Monitor/Observability solution that enables customers to start using GitLab and move away from expensive Monitoring vendors

### Opportunities

1. Instrumentation is commoditized. GitLab will not need to invest in agents since [OpenTelemetry](https://opentelemetry.io) and most vendor agents are all open source.
1. With development shifting cloud-native and the massive community driven investment in tools and patterns, the opportunity to build boring solutions on top of the cloud-native solutions plays right to GitLab's strength.
1. Out-of-the-box monitoring capabilities saves time and money and lowers the bar on the expertise required for enterprises and start-ups. The ease by which most users can start monitoring their service, using established vendors, such as DataDog or New Relic, and newer competitors like Honeycomb, is something we should strive to emulate.
1. Monitoring is traditionally for production, there are opportunities to shift monitoring tools and techniques left.
1. Monitoring vendors are considered, in general, to be expensive. We can compete on cost when monitoring is part of the GitLab single application.

### Challenges

1. Monitoring vendors offer generous free tiers (e.g. [here](https://newrelic.com/pricing) and [here](https://www.honeycomb.io/pricing/)) for smaller companies and complete solutions for enterprises.
1. Huge investments are made by market leaders. Market leaders are also expanding the scope of their solution. This makes them more sticky with their customers.

## What's next

The Monitor surface area is large. Rather than continue to pursue bringing multiple products within the monitor purview to market concurrently, GitLab has consolidated the majority of its current focus to Incident Management. This allows us to complete the [smart feedback loop](/direction/ops/#smart-feedback-loop) within a single DevOps platform as a first priority. With GitLab Incident Management's development timeline, our users will benefit from the advantage of enabling collaboration for incident response within the same tool as their source code management, CI/CD, plan, and release workflows - all within the same tool. This most effectively positions GitLab to gain market traction and user adoption. 

The details of what the Monitor Group is currently working on is listed in [Incident Management Direction](/direction/monitor/debugging_and_health/incident_management/#what-is-next--why).

### Changing direction on Monitoring and Observability

GitLab users previously can monitor their services and application by leveraging GitLab to install Prometheus to a GitLab managed cluster.
Similarly, users can also install the ELK stack to do log aggregation and management. 
The advantage of using GitLab with these popular tools is that users can collaborate on monitoring in the same application they use for building and deploying their services and applications. 
Furthermore, developers, who do not use, or potentially because they don't have access to their organizations monitoring tool, seeing metrics for their service and cluster metrics where their application run is extremely useful.

However, we believe that our solution is niche and reliant on a foundation that will be removed as we are [deprecating GitLab Managed Apps](https://gitlab.com/groups/gitlab-org/-/epics/4280).

What we've learned since that makes this particular strategy challenging are the following:
1. **Not working by default** - GitLab has to first manage the cluster, get users to install additional applications, setup Prometheus exporters, before being able to see a chart. Compared to a vendor that has an agent that auto instruments an application, the high bar is a barrier for adoption.
1. **Mostly self-service** - Users are responsible for managing, scaling, and operating their Prometheus fleet, and ELK stack in order to use GitLab metrics and logging. Not having to manage and pay for the associated infrastructure and people are some main reasons organizations outsource these tasks to vendors. When an organization chooses to manage monitoring on their own, many are perfectly happy just using the open-source tools on their own, without GitLab as an additional layer that does not provide additional value currently.
1. **Wrong market** - We targeted SMBs to use our tools as a cheaper solution relative to other vendors. The problem is the total cost of ownership was not necessarily lower. Furthermore, since GitLab's solution was based on having GitLab manage the customer's Kubernetes cluster, and there wasn't necessarily a significantly large overlap between SMB customers and those that used Kubernetes, it meant our solutions was constrained to a smaller target audience.
We are intentionally shifting our strategy to account for what we learned:
1. We are [removing GitLab Managed Apps](https://gitlab.com/groups/gitlab-org/-/epics/4280)
1. Start with a [SaaS first](https://about.gitlab.com/direction/#saas-first). 
1. Leverage OpenTelemetry and potentially other open-source agents for auto-instrumentation. Potentially leverage the GitLab Kubernetes Agent to setup exporters.
1. Lean into having an integrated monitoring/observability tool all within GitLab.
We will have limited bandwidth to make progress in this space within our development groups. In FY22, we are creating a [Single-Engineer-Group](https://about.gitlab.com/company/team/structure/#single-engineer-groups) to help us kickstart this effort. 
1. Leverage OpenTelemetry and potentially other open-source agents for auto-instrumentation. Potentially leverage the GitLab Kubernetes Agent to setup exporters.

## Performance Indicators (PIs)

Our [Key Performance Indicator](https://about.gitlab.com/handbook/ceo/kpis/) for the Monitor stage is the Monitor
SMAU ([stage monthly active users](https://about.gitlab.com/handbook/product/metrics/#monthly-active-users-mau)).

The Monitor SMAU is based on the [Incident Management category](https://about.gitlab.com/direction/monitor/debugging_and_health/incident_management/). It is the count of unique users that interact with alerts and incidents. This PI will inform us if we are on the right path to provide meaningful incident response tools.
